;================================================================================
;----Avoider Conn----------------------------------------------------------------
;================================================================================


alias localwrite sockwrite -tn sock.local $1-

alias clone { set %cnick $1 | set -u8 %clone $true | sconnect | $iif($chan(0) != $null,.timerjoin 1 5 rejoinall 0) }

on *:start:{ 

  hmake dataq 100 | hmake q 10 | hadd q cur 1
  sconnect
  if (!$hget(banlist)) {
    hmake banlist 100
    if ($exists(data\banlist.hsh)) { hload banlist data\banlist.hsh }
  }
  unset %whis.*
}

alias sconnect {
  if (!%hpass) || (!%uname) pport

  hdel -w dataq * | hdel -w q * | hadd q cur 1

  if ($sock(sock.local)) sockclose sock.*
  if ($sock(init.*)) sockclose init.*

  socklisten init.connection 
  server localhost $sock(init.connection).port
  set -u45 %pingcheck 1 | timer.Ping 0 40 pingTest

}


on *:socklisten:init.connection:{ 

  sockaccept sock.local 
  sockclose $sockname 

  sockopen sock.server irc.buzzen.net 6667

}


on *:sockread:sock.local:{
  while ($sock($sockname).rq) {

    var %r | sockread %r | tokenize 32 %r
    if ($sockbr = 0) return 

    if (($1 == PING) && ($2 == :TIMEOUTCHECK)) localwrite PONG :TIMEOUTCHECK 
    if ($1 = NICK) || ($1 = USER) halt
    if ($1 == KICK) swrite sock.server $1-3 $iif($left($4-,1) == :,$right($4-,-1),$4-)
    if ($1 = PRIVMSG) {
      ;If it's not addressed to a chan, it's addressed to a person.
      if ($left($2,1) != $chr(37)) {
        ;Whisper it to that person, not to the main chan.
        swrite sock.server WHISPER $comchan($2,1) $2 $3-
        halt

      }

      ;;if ($me ison $2) swrite sock.server $1-
      ;If it was a whisper, previous if statement would have halted before now.
      ;If it's not an action and f.text is set, use f.text, otherwise send it stock.
      swrite sock.server PRIVMSG $2 $iif( ($3 != :ACTION) && (%f.text) ,  :[style %f.text $+ ] $+ $right($3-,-1) $+ [/style] , $3- )
      halt

    }
    if ($1 == JOIN) && ($numtok($2,44) > 1) {
      var %x 1
      while ($gettok($2,%x,44)) { join $ifmatch | inc %x }
    }
    if ($1 == AWAY) {
      if ($me ison $remove($2,:)) swrite sock.server $1 $remove($2,:) $iif($left($3-,1) == :,$right($3-,-1),$3-)
      else {
        if ($me ison $active) swrite sock.server $1 $active $iif($left($2-,1) == :,$right($2-,-1),$2-)
        else echo -a To avoid flooding, please specify which channel to change away status. /away <channel> <message>
      }
    }
    if ($sock(sock.server)) swrite sock.server %r
  }
}

on *:sockopen:sock.server:{

  if ($sockerr) { 

    echo -at 4* Connection failed @ $time ! 
    disconnect
    sockclose sock.local
    .timer 1 5 sconnect
    halt 

  }

  if (%uname) swrite $sockname loginh %uname %hpass
  swrite $sockname $iif(%clone == $true,NICK %cnick, USER $me $me $me $+(:,anon))

}

on *:sockclose:sock.server:{

  echo -at 4* Server disconnected. Retrying.
  sockclose sock.local
  sconnect

}

alias q.tot return $hget(dataq,0).item
alias q.cur return $hget(q,cur)
alias q.data return $hget(dataq,$$1)
alias q.add hadd dataq $calc($q.tot + 1) $$1-
alias q.clr {
  hdel -w dataq *
  hadd q cur 1
}

alias sfont {
  return $regsubex($1-,/(\[style (ff:.*?;|(bg)?co?:?.*?;?|[ubi];)[^ ]*?]|\[/style\])/ig,$null)
}

alias swrite {
  if ($1 = -tn) || ($1 = -t) || ($1 = -n) tokenize 32 $2-
  if ($q.tot = 0) .timer.q.advance -m 1 20 q.advance
  q.add $1-
}

alias q.advance {

  var %x 0 

  while (%x <= 11) {

    inc %x

    if ($q.tot >= $q.cur) {
      sockwrite -n $q.data($q.cur)
      hinc q cur 1
    }

    else {
      if ($q.tot = 0) halt
      hdel -w dataq *
      hadd q cur 1
    }

  }

  .timer.q.advance -m 1 1200 q.advance  

}

on *:sockread:sock.server:{

  while ($sock($sockname).rq) {

    var %r | sockread %r
    if ($sockbr = 0) return

    if ($gettok(%r,2,32) = 353) { 

      if ($numtok(%r,32) > 29) { 
        localwrite $gettok(%r,1-30,32) 
        localwrite $gettok(%r,1-5,32) : $+ $gettok(%r,30-,32)
      }

      else { localwrite %r }

      halt

    }

    if ($window(@debug)) echo -t @debug $+(,$sockname,:  %r)

    tokenize 32 $replace($regsubex(%r,/(\[style (u;|bgco:.+?;|ff:.+?;|co:.+?;|b;|i;|\bundefined\b)*?\]|\[\/style\])/ig,$null),&nbsp;,$chr(32),&amp;,&)

    if ($2-3 == NOTICE AUTH) && ($regex($4-,bad password) || $regex($4-,user not found)) {
      sockclose sock.* | disconnect | linesep -s 
      echo $color(kick) -st * User Name and/or Password is incorrect. | return
    }
    elseif ($2 == PRIVMSG) {
      if ($4 == $me) && ($5 == :TIME) {
        var %t.nick = $right($gettok($1,1,33),-1), %rply = $asctime(ddd mmm dd HH:nn:ss) GMT $+ [ $asctime(zz yyyy) ]
        if (%t.nick == %time. [ $+ [ %t.nick ] ]) { access $3 add DENY $address(%t.nick,1) 5 :Possible time flood | kick $3 %t.nick %t.nick $+ ; once is a time request... more often is trouble (5 min ban) | return
        }
        if ($3 == $hget(prots,time. $+ $3)) && (%t.nick !isop $3) && (%t.nick != %admin) {
          access $3 add DENY $address(%t.nick,1) 5 :Time | kick $3 %t.nick Stay out of my time %t.nick (5 min ban) | return
        }
        else set -u5 %time. [ $+ [ %t.nick ] ] %t.nick  | echo -a 4* %t.nick just checked your time | sockwrite -n $sockname NOTICE $3 %t.nick $+($Chr(2),TIME,$chr(2),%rply) | return
      }
      elseif ($regex($1,/^:%#/)) { echo $3 $+(3,$timestamp * Onjoin is,$chr(32),',$right($4-,-1),') }
      else localwrite $regsubex(%r,/\[style[^\]]+\](.*)\[/style\]/i,\1)

    }
    elseif ($2 == WHISPER) { 
      set %whis. [ $+ [ $remove($gettok($1,1,33),:) ] ] $3
      localwrite $1 PRIVMSG $regsubex($4-,/\[style.+\](.+)\[/style\]/i,\1)
      return
    }
    elseif ($1 == PONG) { set -u45 %pingcheck 1 }
    elseif ($2 == DATA) { 
      if ($4 == PID) set %pid $6
      var %n = $regsubex($1,:(.+)!.+@.+,\1)
      if ($6 == :WHISPACCEPTNEEDED) echo $color(notice) -t %n * Waiting for %n to Accept Whisper.
      if ($6 == :WHISPACCEPTED) echo $color(notice) -t %n * %n has Accepted Your Whisper.
      if ($6 == :WHISPDECLINED) echo $color(kick) -t %n * %n has Declined Your Whisper.
      if ($6 == :WHISPWNDCLOSED) echo $color(kick) -t %n * %n has Closed the Whisper Window.
    }
    elseif ($2 == 315) { 
      if ($2 isin %scheck) { set -u20 %scheck $remtok(%scheck,$2,44) }
      halt
    }
    elseif ($2 == 329) return
    elseif ($2 == 352) { 
      if ($11- != anon) {
        if ($4 isin %scheck) { echo -a [4Script] - $8 is not webchat. 10 $11- }
      }
      noop write data\check.txt $3 $6 | halt
    }
    elseif ($2 == 403) && ($regex($4,$+($chr(37),#.+))) CREATE $4
    elseif ($2 == 422) return
    elseif ($2 == 441) return
    elseif ($2 == 800) { .halt }
    elseif ($2 == 801) { if (!$dialog(ac.access)) echo $color(mode) -a * $gettok($3,1,33) adds $lower($5) access: $6 $iif($7 == 0,indefinitely,for $7 minutes) $+ $iif($9- != $null,$chr(44) reason given $+ $9-) | haltdef }
    elseif ($2 == 802) { if (!$dialog(ac.access)) echo $color(mode) -a * $gettok($3,1,33) deletes $lower($5) access: $6 | haltdef }
    /*
    elseif ($2 == 803) { var %x ac.access
      if ($dialog(%x)) {
        did -ra %x 1 Retrieving Access list...
        if ($hget(%x)) hfree %x
        hmake %x 2
        hadd %x num 1
      }
      else {
        linesep -s
        echo -s Start of access list for $2
      }
      haltdef
    }
    elseif ($2 == 804) { var %x ac.access
      if ($dialog(%x)) {
        ;;hadd %x $hget(%x,num) $2-
        hadd %x $hget(%x,num) $5-
        hinc %x num
        did -e %x 1,12,13,14
      }
      else echo $color(info2) -a * $3-
      haltdef
    }
    elseif ($2 == 805) { var %a, %l 1, %x ac.access
      if ($dialog(%x)) {
        did -r %x 1
        while (%l <= $hget(%x,num)) {
          %a = $hget(%x,%l)
          did -a %x 1 $gettok(%a,1-2,32)
          inc %l
        }
        did -d %x 1 $did(%x,1).lines
        did -z %x 1
        did -e %x 1
      }
      else {
        echo -s $2-
        linesep -s
      }
      haltdef
    }
    */
    elseif ($2 == 818) {
      if ($5 == OID) echo -a Getting room props now...
      if ($5 == LOCKED) writeini data\roomprops.ini $4 $5 $remove($6-,$chr(58))
      if ($5 == Language2) halt
      if ($5 == Creation) writeini data\roomprops.ini $4 $5 $asctime($6,mmm d yyyy) at $asctime($6,h:mm tt)
      if ($5 == Creator) writeini data\roomprops.ini $4 $5 $gettok($6,1,33) $clr($gettok($gettok($6,2,33),1,36))
      if ($5 == Name) writeini data\roomprops.ini $4 $5 $remove($6-,$chr(58))
      if ($5 == Language) {
        var %lang $6-
        if ($remove($6-,$chr(58)) == EN) %lang = English
        if ($remove($6-,$chr(58)) == NL) %lang = Dutch
        if ($remove($6-,$chr(58)) == JA) %lang = Japanese
        if ($remove($6-,$chr(58)) == DE) %lang = German
        if ($remove($6-,$chr(58)) == AR) %lang = Arabic
        if ($remove($6-,$chr(58)) == FR) %lang = French
        if ($remove($6-,$chr(58)) == ES) %lang = Spanish
        writeini data\roomprops.ini $4 $5 %lang
      }
      if ($5 == Topic) writeini data\roomprops.ini $4 $5 $remove($6-,$chr(58))
      if ($5 == Onjoin) writeini data\roomprops.ini $4 $5 $remove($6-,$chr(58))
      if ($5 == Onpart) writeini data\roomprops.ini $4 $5 $remove($6-,$chr(58))
      if ($5 == Ownerkey) writeini data\roomprops.ini $4 $5 $remove($6-,$chr(58))
      if ($5 == Hostkey) writeini data\roomprops.ini $4 $5 $remove($6-,$chr(58))
      if ($5 == CATEGORY) {
        if (GN isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 General
        if (CP isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 Computing
        if (II isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 Interests
        if (TN isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 Teens
        if (CC isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 City Chat
        if (RM isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 Romance
        if (HE isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 Heath & Medicine
        if (LF isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 Lifestyles
        if (MU isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 Music
        if (NW isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 News
        if (PR isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 Peers
        if (RL isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 Religion
        if (SP isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 Sports and Recreation
        if (EA isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 Entertainment
        if (UL isin $remove($6-,$chr(58))) writeini data\roomprops.ini $4 $5 Unlisted
      }
      else halt
    }
    ;;elseif ($2 == 818) echo $color(info) -t $4 * $5-
    elseif ($2 == 819) { var %x | %x = echo $2 11End of properties list | halt }
    elseif ($2 == 822) { 
      if ($me ison $3) {
        if ($gettok($right($1,-1),1,33) != $me) echo $3 6* $gettok($right($1,-1),1,33) has been marked as being away.
        cline -m 15 $3 $gettok($right($1,-1),1,33)
      }
    }
    elseif ($2 == 821) {
      if ($me ison $3) {
        if ($gettok($right($1,-1),1,33) != $me) echo $3 6* $gettok($right($1,-1),1,33) is no longer marked as being away.
        cline -m 0 $3 $gettok($right($1,-1),1,33)
      }
    }
    else localwrite %r
  }
}

on 1:open:?:{ var %x 1, %y 
  while ($comchan($nick,%x)) { %y = $addtok(%y,$ifmatch,44) | inc %x }
  echo $nick * Common $+([,$comchan($nick,0),]:) %y | linesep $nick
}

alias joinfave {
  var %x $1-
  inc %x
  if (%x > $numtok(%recent, 32)) { .echo -a 7* All recent rooms joined... | halt }
  else {
    join $chr(37) $+ $gettok(%recent, %x, 32)
    timerjoiner -m 1 $r(2,4) $+ 000 joinfave %x
  }
}

alias rejoinall {
  var %x $1-, %n.chan $chan(0)
  inc %x
  if (%x > %n.chan) { .echo -a 7* All rooms rejoined... | halt }
  else {
    var %j.chan $chan(%x)
    JOIN %j.chan
    timerjoiner -m 1 $r(2,4) $+ 000 rejoinall %x
  }
}

alias pingTest { 
  if (%pingcheck == 1) .raw ping ping.chk | return
  else sconnect | timer.join 1 4 rejoinall 0 | return
}

;;Recent Channel
alias read.recent {
  var %x 1

  while (%x <= $numtok(%recent, 32)) {
    var %rchan = $gettok(%recent, %x, 32)

    if ($1 == %x) return $+(%1, .) $chr(37) $!+ %rchan : join $chr(37) $!+ %rchan
    inc %x
  }
}

alias wr.recent {
  var %c = $remove($1, $chr(37))

  if (%c !isin %recent) {
    if ($numtok(%recent, 32) < 10) %recent = %recent %c

    else %recent = %c $gettok(%recent, 1-9, 32)
  }
}

;--Passport dialog.

alias pport dialog -m tblpassport tblpassport

dialog tblPassport {

  title "Very Simple Passport [/pport]"
  option dbu toolbar

  size                    -1  -1  120  40
  text   "Address:",  1,   5   5   28   8, right
  text   "Password:", 2,   5  16   28   8, right
  edit   "",          3,  33   4   85  10
  edit   "",          4,  33  15   85  10, pass
  button "Okay",      5,   4  26  114  11, flat
}

on *:dialog:tblpassport:sclick:5: {

  if (%uname != $did(3)) && ($did(3)) set %uname $did(3)
  if (%hpass != $md5($did(4))) && ($did(4)) set %hpass $md5($did(4))
  sconnect
  dialog -x $dname

}

alias pport dialog -m tblpassport tblpassport

dialog tblPassport {
  title "Passport [/pport]"
  size -1 -1 120 40
  option dbu toolbar
  text "Address:", 1, 5 5 28 8, right
  text "Password:", 2, 5 16 28 8, right
  edit "", 3, 33 4 85 10
  edit "", 4, 33 15 85 10, pass
  button "Okay", 5, 4 26 114 11, flat
}

on *:dialog:tblPassport:init:0: {
  .splay password.wav

  dll $mdx SetBorderStyle 1,2 staticedge
  dll $mdx SetMircVersion $version
  dll $mdx MarkDialog $dname
  dll dll\mdx.dll SetBorderStyle 1,2  14 50 Georgia Bold
  dll dll\mdx.dll SetColor $dname 1,2 text $rgb(%list1colour,%list2colour,%list3colour)
  dll $mdx SetFont $dname 3,4 Georgia Bold
  mdx SetFont 3,4 +a 12 100 Verdana

  colorize
}

on *:dialog:tblpassport:sclick:5: {
  if (%uname != $did(3)) && ($did(3)) set %uname $did(3)
  if (%hpass != $md5($did(4))) && ($did(4)) set %hpass $md5($did(4))
  sconnect
  dialog -x $dname
}




;--Access dialog.


;--Channel Create
dialog chan.create {
  title "Channel Creator"
  size -1 -1 181 77
  option dbu
  text "Room Name:", 1, 2 6 32 10, right
  edit "My Room", 2, 35 5 141 10
  text "Category:", 3, 2 20 32 10, right
  combo 4, 35 19 63 53, drop
  text "Language:", 5, 99 20 27 10, right
  combo 6, 127 19 49 53, drop
  text "Topic:", 8, 2 34 32 10, right
  edit "Topic for My Room", 9, 35 33 141 10, autohs
  text "Onjoin:", 10, 2 48 32 10, right
  edit "Onjoin message for My Room", 11, 35 47 141 10, autohs
  text "Room Limit:", 12, 1 62 32 10, right
  edit "50", 13, 35 61 29 10
  button "Cancel", 14, 105 61 30 10, cancel
  button "OK", 15, 141 61 35 10, ok
  button "Clear", 7, 69 61 30 10
}

alias chan.create { dialog -mdo chan.create chan.create }

on *:dialog:chan.create:init:*:{
  didtok $dname 4 44 Unlisted (UN),General (GN),Romance (RM),Computing (CP),Peers (PR),Interests (IN),News & Events (NE),Sports & Politics (SP),City Chats (CC),Lifestyles (LS),Entertainment (ET),Religion (RL) 
  didtok $dname 6 44 Chinese (ZH),Arabic (AR),Turkish (TR),Portuguese (PT),Malay (MS),Japanese (JA),Italian (IT),Indonesian (ID),Hindi (HI),Herbrew (HE),Finnish (FI),Greek (EL),Danish (DA),Dutch (NL),English (EN),Spanish (ES),French (FR),German (DE)
  did -c $dname 4 2 | did -c $dname 6 15
}

on *:dialog:chan.create:sclick:7:{ 
  did -r $dname 2  | did -r $dname 9 | did -r $dname 11 | did -r $dname 13
}

on *:dialog:chan.create:sclick:15:{ 
  var %ch.room $chr(37) $+ $chr(35) $+ $replace($did(2),$chr(32),\b), %ch.cat $remove($gettok($did(4).seltext,2,32),$chr(40),$chr(41)), %ch.lang $remove($gettok($did(6).seltext,2,32),$chr(40),$chr(41))
  var %ch.topic $did(9), %ch.onjoin $did(11), %ch.limit $iif($did(13) isnum 1-100,$did(13),50)
  if ($did(2) != $null) { 
    create %ch.room $+ $crlf $+ prop %ch.room unlock category $+ $crlf $+ prop %ch.room language %ch.lang $+ $crlf $+ prop %ch.room category %ch.cat $+ $crlf $+ prop %ch.room topic %ch.topic $+ $crlf $+ prop %ch.room onjoin %ch.onjoin $+ $crlf $+ mode %ch.room +l %ch.limit | return
  }
  else echo -a 4 ** No room name entered; cannot create room |  halt
}

;;Nick Decode
alias n.dc {
  var %r, %l 1
  %r = $replace($1-,,B,,-,>,-,,-,,-,,E,,C,,A,,R,,K,,y,ﺘ,i,ﺉ,s,דּ,t,טּ,u,ﻉ,e,,k,,F,,u,,g,Χ,X,,>,,$chr(37),,8,,d,,m,,h,ﻛ,s,,G,,M,,l,,s,,_,,T,,r,,a,,n,,c,,e,,N,,a,,t,,i,,o,,n,,f,,w,,\,,|,,@,,P,,D,,',,,,$chr(40),,$chr(41),,*,,:,,[,,],,p,,.)
  %r = $replace(%r,ا,I,ή,n,ņ,n,Ω,n,,y,р,p,Р,P,ř,r,х,x,Į,I,Ļ,L,Ф,o,Ĉ,C,ŏ,o,ũ,u,ń,n,Ģ,G,ŕ,r,ś,s,ķ,k,Ŗ,R,ז,i,ε,e,ק,r,ћ,h,м,m,،,,ī,i,‘,,’,,۱,',ē,e,¢,,,S,•,,,O,,I,Ά,A,ъ,b,,T,Φ,o,Ђ,b,я,r,Ё,E,д,A,К,K,Ď,D,и,n,θ,o,М,M,Ї,I,Т,T,Є,e,Ǻ,A,ö,,ä,,–,,·,,Ö,,Ü,,Ë,,ѕ,s,ą,a,ĭ,i,й,n,в,b,о,o,ш,w,Ğ,G,đ,d,з,e,Ŧ,T,α,a,ğ,g,ú,,Ŕ,R,Ą,A,ć,c,Đ,,Κ,K,ў,y,µ,,Í,,‹,,¦,,Õ,,Ù,,À,,Π,N,ғ,f,ΰ,u,Ŀ,L,ō,o,ς,c,ċ,c,ħ,h,į,i,ŧ,t,Ζ,Z,Þ,,þ,,ç,,á,,¾,,ž,,Ç,, $+ $chr(173),-,Á,,…,,¨,,ý,,ˉ,,”,,Û,,ì,,ρ,p,έ,e,г,r,à,,È,,¼,,ĵ,j,ã,,ę,e,ş,s,º,,Ñ,,ã,,Æ,,˚,,Я,R,˜,,Î,,Ê,,Ý,,Ï,,É,,‡,,Ì,,ª,,ó,,™,,Ò,,í,,¿,,Ä,,¶,,ü,,ƒ,,ð,,ò,,õ,,¡,,é,,ß,,¤,,×,,ô,,Š,,ø,,›,,â,,î,,€,,š,,ï,,ÿ,,Ń,N,©,,®,,û,,†,,°,,§,,±,,è,)
  %r = $replace(%r,Ƥ,P,χ,X,Ň,N,۰,,Ĵ,J,І,I,Σ,E,ι,i,Ő,O,δ,o,ץ,y,ν,v,ע,y,מ,n,Ž,,ő,o,Č,C,ė,e,₤,L,Ō,O,ά,a,Ġ,G,Ω,O,Н,H,ể,e,ẵ,a,Ж,K,ề,e,ế,e,ỗ,o,ū,u,₣,F,∆,a,Ắ,A,ủ,u,Ķ,K,Ť,T,Ş,S,Θ,O,Ш,W,Β,B,П,N,ẅ,w,ﻨ,i,ﯼ,s,џ,u,ђ,h,¹,,Ỳ,Y,λ,a,С,C, $+ $chr(173),E,Ű,U,Ī,I,č,c,Ĕ,E,Ŝ,S,Ị,I,ĝ,g,ŀ,l,ї,i,٭,*,ŉ,n,Ħ,H,Д,A,Μ,M,ё,e,Ц,U,э,e,“,,ф,o,у,y,с,c,к,k,Å,,℞,R,,I,ɳ,n,ʗ,c,▫,,ѓ,r,ệ,e,ắ,a,ẳ,a,ů,u,Ľ,L,ư,u,·,,˙,',η,n,ℓ,l,,,,,,,׀,i,ġ,g,Ŵ,W,Δ,A,ﮊ,J,μ,,Ÿ,,ĥ,h,β,,Ь,b,ų,u,є,e,ω,w,Ċ,C,і,i,ł,l,ǿ,o,∫,l,ż,z,ţ,t,æ,,≈,=,Ł,L,ŋ,n,گ,S,ď,d,ψ,w,σ,o,ģ,g,Ή,H,ΐ,i,ґ,r,κ,k,Ŋ,N,,\,,/,¬,,щ,w,ە,o,ם,o,³,,½,,İ,I,ľ,l,ĕ,e,Ţ,T,ŝ,s,ŷ,y,ľ,l,ĩ,i,Ô,,Ś,S,Ĺ,L,а,a,е,e,Ρ,P,Ј,J,Ν,N,ǻ,a,ђ,h,ί,l,Œ,,¯,,ā,a,ŵ,w,Â,,Ã,,н,H,ˇ,',¸,,̣,$chr(44),ط,b,Ó,,Й,N,«,,ù,,Ø,,ê,)
  %r = $replace(%r,²,,л,n,ы,bl,б,6,ש,w,―,-,Ϊ,I,,`,ŭ,u,ổ,o,Ǿ,,ẫ,a,ầ,a,,q,Ẃ,W,Ĥ,H,ỏ,o,−,-,,^,ล,a,Ĝ,G,ﺯ,j,ى,s,Ѓ,r,ứ,u,●,,ύ,u,,0,,7,,",ө,O,ǐ,i,Ǒ,O,Ơ,O,,2,ү,y,,v,А,A,≤,<,≥,>,ẩ,a,,H,٤,e,ﺂ,i,Ќ,K,Ū,U,,;,ă,a,ĸ,k,Ć,C,Ĭ,I,ň,n,Ĩ,I,Ι,I,Ϋ,Y,,J,,X,,$chr(125),,$chr(123),Ξ,E,ˆ,^,,V,,L,γ,y,ﺎ,i,Ώ,o,ỳ,y,Ć,C,Ĭ,I,ĸ,k,Ŷ,y,๛,c,ỡ,o,๓,m,ﺄ,i,פֿ,G,Ŭ,U,Ē,E,Ă,A,÷,, ,,‚,,„,,ˆ,,‰,,ă,a,,x,,=,ق,J,,?,￼,-,◊,o,т,T,Ā,A,קּ,P,Ė,E,Ę,E,ο,o,ϋ,u,‼,!!,ט,u,ﮒ,S,Ч,y,Ґ,r,ě,e,Ę,E,ĺ,I,Λ,a,ο,o,Ú,,Ř,R,Ư,U,œ,,,-,—,,ห,n,ส,a,ฐ,g,Ψ,Y,Ẫ,A,π,n,Ņ,N,!,o,Ћ,h,ợ,o,ĉ,c,◦,,ﮎ,S,Ų,U,Е,E,Ѕ,S,۵,o,ي,S,ب,u,ة,o,ئ,s,ļ,l,ı,i,ŗ,r,ж,x,΅,",ώ,w,▪,,ζ,l,Щ,W,฿,B,ỹ,y,ϊ,i,ť,t,п,n,´,,ک,s,ﱢ,*,ξ,E,ќ,k,√,v,τ,t,Ð,,£,,ñ,,¥,,ë,,å,,,Y,ǎ,a)
  %r = $replace(%r,ằ,a, ,,Ο,O,₪,n,Ậ,A,,,,,,,,,,,,,ờ,o,‍,,ֱ,,־,-,הּ,n,ź,z,‌,,ُ,',๘,c,ฅ,m,,,,<,▼,v,ﻜ,S,℮,e,ź,z,ậ,a,๑,a,ﬁ,fi,ь,b,ﺒ,.,ﺜ,:,ศ,a,ภ,n,๏,o,ะ,=,צּ,y,ซ,i,‾,,∂,a,：,:,≠,=,,+,م,r,ồ,o,Ử,U,Л,N,Ӓ,A,Ọ,O,Ẅ,W,Ỵ,Y,ﺚ,u,ﺬ,i,ﺏ,u,Ż,Z,ﮕ,S,ﺳ,w,ﯽ,u,ﺱ,uw,ﻚ,J,ﺔ,a,,!,ễ,e,ل,J,ر,j,ـ,_,ό,o,₫,d,№,no,ữ,u,Ě,E,φ,o,ﻠ,I,ц,u,,,,N,Њ,H,Έ,E,,~,,U,ạ,a,,1,,4,,3,ỉ,i,Ε,E,Џ,U,ك,J,★,*,,b,,$chr(35),,$,○,o,ю,10,ỵ,y,ẁ,w,қ,k,ٿ,u,♂,o,תּ,n,٥,o,ﮐ,S,ⁿ,n,ﻗ,9,,b,,$chr(35),,$,○,o,ю,10,ị,i,Α,A, ,,ﻩ,o,ﻍ,E,ن,u,ẽ,e,ث,u,ㅓ,t,ӛ,e,Ә,E,ﻘ,o,۷,v,שׁ,w,ụ,u,Ŏ,O,,,ự,u,Ｊ,J,ｅ,e,ａ,a,Ｎ,N,（,$chr(40),＠,@,｀,`,．,.,′,',）,$chr(41),▬,-,◄,<,►,>,∑,E,ֻ,$chr(44),‬,|,‎,|,‪,|,‫,|,Ộ,O,И,N,,W,,z)
  %r = $replace(%r,ס,o,╳,X,٠,,Ғ,F,υ,u,‏,,ּ,,ǔ,u,ผ,w,Ằ,A,Ấ,A,»,,ﺖ,u,ố,o,ﮓ,S,ở,o,ﺕ,u,ﮔ,S, Ҝ,K,♦,,‗,_,ﻈ,b,ฬ,w,אּ,x,,-,ข,u,ท,n,Ờ,O,Ặ,A,ử,u,Ễ,E,ਹ,J, ه,o,■,,ơ,o,,,ң,h,Қ,K,Ҳ,X,ҳ,x,Ҝ,K,ع,E,چ,c,ч,y,Х,X,٦,7,ֽ,.,َ,',ֿ,',׃,:,ọ,o,Җ,X,ی,s,ฬ,w,∙,,Τ,T,ⓒ,c,ⓐ,a,ⓟ,p,ⓔ,e,ⓣ,t,Ǎ,A,Х,X,ֳ,.,ی,s,Ỉ,I,̉,',,Z,ọ,o,ẹ,e,ҝ,k,ﺖ,u,ố,o,ﮓ,S,ở,o,ﺕ,u,Қ,K,,Z,̕,',├,|,┤,|,أ,I,,,א,x,ặ,a,ǒ,o,Ờ,O,☼,,ׁ,.,,Z,ฤ,n,⑷,4,⑵,2,⒪,0,เ,i,☻,,╠,|,╦,n,十,,ấ,a,,,З,3,Ẵ,A,Ў,y,Ź,Z,΄,',,$chr(40),,$chr(41),ח,n,Ở,O,Ổ,O,์,',,g,В,B,【,[,】,],ｓ,s,ｍ,m,ｏ,o,ｋ,k,ｗ,w,ｄ,d,Ũ,U,,Q,↨,|,Ẩ,A,Ẽ,E,ָ,,ธ,s,و,g,з,e,ظ,b,ﺸ,,Б,b,-,m,ﻲ,,پ,u,غ,e,Ẩ,A,ẻ,e,ҹ,y,ฆ,u,ฯ,-,ׂ,,,-,,,,,ת,n,٧,V,Ợ,O,۝,I,۞,O,۩,O,,:,{,;)
  return %r
}

alias channel.list { 
  var %c $$1 , %p $2 | unset %channel.list* 
  set %channel.list.total 0 | set %channel.list.ticks $ticks | set %channel.list.users 0

  if ($sock(channel.list)) sockclose $ifmatch
  if (!$window(@channel.list)) window -lkf -t25,29 @channel.list verdana 10
  channel.list.buf 1 | titlebar @channel.list - $channel.list.flip(%c) $iif(%p,- Page: %p)

  sockopen channel.list www.buzzen.net 80
  sockmark channel.list %c %p
}

alias channel.list.flip return $gettok($channel.list.cat(2),$findtok($channel.list.cat(1),$$1,44),44)

alias channel.list.cat {
  if ($$1 == 1) return UN,GN,RM,CP,PR,IN,NE,SP,CC,LS,ET,RL,RP
  elseif ($$1 == 2) return Unlisted,General,Romance,Computing,Peers,Interests,News & Events,Sports & Politics,City Chats,Lifestyles,Entertainment,Religion,RolePlay
}

alias channel.list.menu1 {
  if ($1 isin begin end) return
  if ($gettok($channel.list.cat(2),$1,44)) { var %i $ifmatch | return $+($iif($regex($window(@channel.list).title,%i),$style(3)) %i,:,channel.list $gettok($channel.list.cat(1),$1,44)) }
}

alias channel.list.menu2 {
  if ($1 <= $gettok(%channel.list.num,1,32)) return $1 :channel.list $gettok(%channel.list.num,2,32) $1
}

alias channel.list.buf {
  if ($1 == 1) {
    clear @channel.list
    aline @channel.list $chr(160)
    aline @channel.list Room $chr(9) Users $chr(9) Topic
    aline @channel.list $chr(160)
  }
  if ($1 == 2) {
    aline @channel.list $chr(160)
    aline @channel.list - Synched in: $+(,$calc(($ticks - %channel.list.ticks) / 1000),s) $chr(160) Channels: $+(,%channel.list.total,) $chr(160) Users: $+(,%channel.list.users,)
  }
}

on 1:sockopen:channel.list:{
  tokenize 32 $sock($sockname).mark
  var %str $+(/roomslist.aspx?,$iif($2,$+(pg=,$2,&)),cat=,$1)
  sockwrite -n $sockname POST %str HTTP/1.4
  sockwrite -n $sockname Host: www.buzzen.net
  sockwrite -n $sockname Content-Length: $len(%str) $+ $str($crlf,2) $+ %str
  sockwrite -n $Sockname $crlf
}

on 1:sockread:channel.list:{
  var %r | sockread %r 
  if ($regex(%r,Title2".Pages:)) && ($regsubex(%r,/^[^<]*>|<[^>]*>|<[^>]*$/g,)) && ($numtok($gettok($v1,2-,32),32) > 1) {
    tokenize 32 $sock($sockname).mark
    set %channel.list.num $v1 $1
  }
  if ($regex(%r,chatui.+rmlist)) {
    tokenize 1 $regsubex(%r,/^[^<]*>|<[^>]*>|<[^>]*$/g,$chr(1)) | inc %channel.list.total

    var %u $iif(!$regex(%r,</a></td><td></td>),$4,$3)
    %channel.list.users = %channel.list.users + %u

    aline @channel.list $+($chr(37),$chr(35),$replace($2,$chr(32),\b)) $chr(9) $chr(160) %u $chr(9) $iif(!$regex(%r,</a></td><td></td>),$3)
  }
  if ($regex(%r,</HTML>)) { sockclose $sockname | channel.list.buf 2 }
}

on *:close:@channel.list:unset %channel.list*


;;;Channel List Menus

menu @channel.list {
  dclick:join $gettok($sline(@channel.list,1),1,9)

   Join Channel:join $$gettok($sline(@channel.list,1),1,9)
  -
   Category Select
  .$submenu($channel.list.menu1($1))
   $iif(%channel.list.num,Select Page)
  . $submenu($channel.list.menu2($1))
  -
   Channel Link
  . Echo Link In Status:echo -st * Link: http://www.buzzen.net/chatui.aspx?rm=%25%23 $+ $replace($right($gettok($sline(@channel.list,1),1,9),-2),\b,+)
  . Copy Link:clipboard http://www.buzzen.net/chatui.aspx?rm=%25%23 $+ $replace($right($gettok($sline(@channel.list,1),1,9),-2),\b,+)
  . Run in Webchat:run iexplore http://www.buzzen.net/chatui.aspx?rm=%25%23 $+ $replace($right($gettok($sline(@channel.list,1),1,9),-2),\b,+)
}














;EOF
